<?php
namespace Pessek\PessekChat;
/*
use Elgg\Hook;
use Elgg\Event;
use ElggMenuItem;

use Elgg\Request;
use Elgg\Http\ResponseBuilder;
*/

class PessekChatConfig {
	
	/**
	 * Add menu items to the topbar
	 *
	 * @param string          $hook         the name of the hook
	 * @param string          $type         the type of the hook
	 * @param \ElggMenuItem[] $return_value the current return value
	 * @param array           $params       supplied params
	 *
	 * @return void|\ElggMenuItem[]
	 */

	public static function pessekChatConfigUserPage($hook, $type, $value, $params) {
	
	    	$guid = elgg_get_logged_in_user_entity()->guid;
	    	$user = get_user($guid);
	    	$elgg_username = $user->username;
	   	$current_lang = get_current_language();
	    
	    	$value['pessek_chat']['user_jid'] = $elgg_username .'@'.trim(elgg_get_plugin_setting('userxmppdomain', 'pessek_chat'));
	    	$value['pessek_chat']['bosh_service_url'] = trim(elgg_get_plugin_setting('boshurl', 'pessek_chat'));
	    	$value['pessek_chat']['websocket_url_non_secure'] = trim(elgg_get_plugin_setting('websocketurl', 'pessek_chat'));
	    	$value['pessek_chat']['websocket_url_secure'] = trim(elgg_get_plugin_setting('websocketurl_secure', 'pessek_chat'));
	    	$value['pessek_chat']['credentials_url'] = elgg_get_site_url() . 'chatusersettings';
	    	$value['pessek_chat']['prebind_url'] = elgg_get_site_url() . 'chatusersettingsprebind';
	    	$value['pessek_chat']['userxmppdomain'] = trim(elgg_get_plugin_setting('userxmppdomain', 'pessek_chat'));
	    	$value['pessek_chat']['sounds_path'] = elgg_get_site_url() . 'mod/pessek_chat/lib/sounds/';
	    	$value['pessek_chat']['notification_icon'] = elgg_get_site_url() . 'mod/pessek_chat/images/';
	    	$value['pessek_chat']['site_url'] = elgg_get_site_url();
	    	$value['pessek_chat']['user_jid_pass'] = base64_decode ($user->pessekchat_secret_key);
	    	$value['pessek_chat']['view_mode'] = $user->chatViewMode; 
	    
	    	return $value;
	}

	public static function pessekChatConfigUserSite($hook, $type, $value, $params) {

	    	$guid = elgg_get_logged_in_user_entity()->guid;
	    	$user = get_user($guid);
	    	$elgg_username = $user->username;
	   	$current_lang = get_current_language();
	    
	    	$value['pessek_chat']['user_jid'] = $elgg_username .'@'.trim(elgg_get_plugin_setting('userxmppdomain', 'pessek_chat'));
	    	$value['pessek_chat']['bosh_service_url'] = trim(elgg_get_plugin_setting('boshurl', 'pessek_chat'));
	    	$value['pessek_chat']['websocket_url_non_secure'] = trim(elgg_get_plugin_setting('websocketurl', 'pessek_chat'));
	    	$value['pessek_chat']['websocket_url_secure'] = trim(elgg_get_plugin_setting('websocketurl_secure', 'pessek_chat'));
	    	$value['pessek_chat']['credentials_url'] = elgg_get_site_url() . 'chatusersettings';
	    	$value['pessek_chat']['prebind_url'] = elgg_get_site_url() . 'chatusersettingsprebind';
	    	$value['pessek_chat']['userxmppdomain'] = trim(elgg_get_plugin_setting('userxmppdomain', 'pessek_chat'));
	    	$value['pessek_chat']['sounds_path'] = elgg_get_site_url() . 'mod/pessek_chat/lib/sounds/';
	    	$value['pessek_chat']['notification_icon'] = elgg_get_site_url() . 'mod/pessek_chat/images/';
	    	$value['pessek_chat']['site_url'] = elgg_get_site_url();
	    	$value['pessek_chat']['user_jid_pass'] = base64_decode ($user->pessekchat_secret_key);
	    	$value['pessek_chat']['view_mode'] = $user->chatViewMode; 
	    
	    	return $value;
	}

	public static function handle_before_login(Event $event) {
	    
             elgg_require_js('pessek_chat/converse.logout');

	}

	public static function adminOrSeftAccountCreation($event, $object_type, $user) {
		
		if (!$user instanceof \ElggUser){ 
		 	return;
		}

		$guid = (string) $user->guid ;
		$chat_username = $user->username;
		$chat_password = get_input('password', null, false);
		$usergroup = elgg_echo('pessek_chat:settings:usergroup');
		//--save base64 user password

		$base64_password = base64_encode ($chat_password);
		$user->pessekchat_secret_key = $base64_password;
		$user->save();

		$pessek_prc = new \Pessek\PessekChat\PessekPrcXmlrpcElgg();   
		$pessek_prc->checkAccountCreated($chat_username, $usergroup, $chat_password, $guid);

	}

	public static function handleAfterLogin($event, $object_type, $user) { 

		$user_guid = elgg_get_logged_in_user_entity()->guid;		
		$user = get_user($user_guid);
		
		if (!$user instanceof \ElggUser){
		 	return;
		}

		$password = get_input('password', null, false);
	   	$user_guid = (int) $user->guid;
	    	$elgg_username = $user->username;
	    	$usergroup = elgg_echo('pessek_chat:settings:usergroup');

	    	if(isset($password) && $password!=''){
			if(isset($user->pessekchat_secret_key) && $user->pessekchat_secret_key!=''){
	    
				$oldpassword = base64_decode ($user->pessekchat_secret_key);
				$newpassword = base64_encode ($password);

				if(strcmp($oldpassword, $newpassword) !=0){

					$chat_user = new \Pessek\PessekChat\PessekPrcConnector($elgg_username, $usergroup, $user->pessekchat_secret_key, $password);
					if($chat_user->check_account() === true ){
						$chat_user->changePassword(); 
						$base64_password = base64_encode ($password);
						$user->pessekchat_secret_key = $base64_password;
						$user->save();	
					}
				}
	    
			}
			
			$base64_password = base64_encode ($password);
			$user->pessekchat_secret_key = $base64_password;
			$user->save();

	    	}

		//trigger when password forgotten
	  	$password2 = get_input('password2', null, false);
	   	$password1 = get_input('password1', null, false);
           	if(isset($password2) && $password2!='' && isset($password1) && $password1!=''){
			$chatUser = new \Pessek\PessekChat\PessekPrcConnector($elgg_username, $usergroup, $user->pessekchat_secret_key, $password1);
			if($chatUser->check_account() === true ){
				$chatUser->changePassword(); 
				$base64_password = base64_encode ($password2);
				$user->pessekchat_secret_key = $base64_password;
				$user->save();
			}
	   	}
		//
	    
	}

	public static function xmppUserDeleteByAdmin($event, $object_type, $user) {
	    
		$user_guid = elgg_get_logged_in_user_entity()->guid;		
		$user = get_user($user_guid);

		if (!$user instanceof \ElggUser){
		 	return;
		}
		  
		$guid = (string)$user->guid ;
		$chat_username = $user->username;
		$chat_password = get_input('password', null, false);
		$usergroup = elgg_echo('pessek_chat:settings:usergroup');
		    
		$user->pessekchat_secret_key = base64_encode ($chat_password);
		
		$pessek_prc = new \Pessek\PessekChat\PessekPrcXmlrpcElgg();
  
		$pessek_prc->deleteXMPPUser($chat_username, $usergroup, $chat_password, $guid);

	}

	public static function friendshipDelete($event, $object_type, $relationship) {

		$test = 0;

		$sender = get_entity($relationship->guid_one);
		$receiver = get_entity($relationship->guid_two);
		
		if (!$relationship instanceof \ElggRelationship) {
			return;
		}

		$sender_username = $sender->username;
		$receiver_username = $receiver->username;

		$sender_displayname = $sender->name;
		$receiver_displayname = $receiver->name;

		$eventval = "delete";
		
		$usergroup = elgg_echo('pessek_chat:settings:usergroup');

		if(strcmp($event, $eventval)==0){

			if (check_entity_relationship($sender->getGUID(), 'friend', $receiver->getGUID())==true && check_entity_relationship($receiver->getGUID(), 'friend', $sender->getGUID())==true){
				//register_error(elgg_echo('friend_request:approve:fail', [$event]));
				$test++;
			}
		
			if($test==0){
				
				$UserSender = new \Pessek\PessekChat\PessekPrcConnector($sender_username, $usergroup);

				$UserReceiver = new \Pessek\PessekChat\PessekPrcConnector($receiver_username, $usergroup);
				
				if($UserSender->check_account() === true && $UserReceiver->check_account() === true){
					$pessek_prc = new \Pessek\PessekChat\PessekPrcXmlrpcElgg();
					$pessek_prc->removeFriendship($UserSender, $UserReceiver);
					$pessek_prc->removeFriendship($UserReceiver, $UserSender);
				}
			}
		}
	}

	public static function friendshipAdd($event, $object_type, $relationship) {

		if (!$relationship instanceof \ElggRelationship) {
			return;
		}
		
		if ($relationship->relationship !== 'friendrequest' && $relationship->relationship !== 'friend') {
			return;
		}

		$sender = get_entity($relationship->guid_one);
		$receiver = get_entity($relationship->guid_two);
		
		$requester = get_user($relationship->guid_one);
		$new_friend = get_user($relationship->guid_two);
		
		if (empty($requester) || empty($new_friend)) {
			return;
		}

		$chat_password = base64_decode ($sender->pessekchat_secret_key);

		$sender_username = $sender->username;
		$receiver_username = $receiver->username;

		$sender_displayname = ucwords(strtolower($sender->getDisplayName()));
		//$sender_displayname =  ucwords($sender_displayname);
		
		$receiver_displayname = ucwords(strtolower($receiver->getDisplayName()));
		//$receiver_displayname = ucwords($receiver_displayname);

		$eventval = "create";
		
		$usergroup = elgg_echo('pessek_chat:settings:usergroup');       

		if(strcmp($event, $eventval)==0){
		    
		    if($relationship->relationship === 'friendrequest'){
	    
		        $UserSender = new \Pessek\PessekChat\PessekPrcConnector($sender_username, $usergroup, $chat_password);
		        $UserReceiver = new \Pessek\PessekChat\PessekPrcConnector($receiver_username, $usergroup,  $chat_password);
		        $pessek_prc = new \Pessek\PessekChat\PessekPrcXmlrpcElgg();
		        $pessek_prc->sendAcceptInvitation($UserSender, $UserReceiver, $receiver_displayname, "both");//from
		        
		        //$pessek_prc->sendAcceptInvitation($UserReceiver, $UserSender, $sender_displayname);
		        $pessek_prc->invitation_v($UserSender, $UserReceiver, $receiver_displayname);
		        //register_error('friendrequest');
		        
		    }
		    
		    if($relationship->relationship === 'friend'){
		        
		        $UserSender = new \Pessek\PessekChat\PessekPrcConnector($sender_username, $usergroup, $chat_password);
		        $UserReceiver = new \Pessek\PessekChat\PessekPrcConnector($receiver_username, $usergroup,  $chat_password);
		        $pessek_prc = new \Pessek\PessekChat\PessekPrcXmlrpcElgg();
		        $pessek_prc->sendAcceptInvitation($UserSender, $UserReceiver, $receiver_displayname, "both");
		        $pessek_prc->sendAcceptInvitation($UserReceiver, $UserSender, $sender_displayname, "both");
		        //register_error('friend');
		    }
		}
	}

	public static function xmppAvatarUpdate($event, $object_type, $user) {

	    if (!$user instanceof \ElggUser){
		 	return;
	    }
	   
	    $icon = $user->getIcon('large');
	    $contents = $icon->grabFile();
	    $photo_binval = base64_encode($contents);

	    $photo_type = "image/jpeg";
	    
	    $elgg_username = $user->username;
	    
	    $chat_user = new \Pessek\PessekChat\PessekPrcConnector($elgg_username);
	    
	    if($chat_user->check_account() === true ){
		    $pessek_prc = new \Pessek\PessekChat\PessekPrcXmlrpcElgg();
		    $pessek_prc->chatUserVcardAvatar($chat_user, $chat_user, "PHOTO", "TYPE", $photo_type);
		    $pessek_prc->chatUserVcardAvatar($chat_user, $chat_user, "PHOTO", "BINVAL", $photo_binval);
	    }
	}

	public static function xmppUserUpdate($event, $object_type, $user) {

	    $DisplayName = $user->getDisplayName();
	    $password = get_input('password', null, false);
	    
	    $guid = elgg_get_logged_in_user_entity()->guid;
		
	    if (!$user instanceof \ElggUser){
		 	return;
	    }

	    $usergroup = elgg_echo('pessek_chat:settings:usergroup');
	    $elgg_username = $user->username;

	    $chat_user = new \Pessek\PessekChat\PessekPrcConnector($elgg_username);
	    
	    if($chat_user->check_account() === true ){
	    	$pessek_prc = new \Pessek\PessekChat\PessekPrcXmlrpcElgg();
		$pessek_prc->chatUserVcardPublic($chat_user, $chat_user, "FN", $DisplayName);

		if(str_word_count($DisplayName)>3){
		        $Nick = array();
		        $Nick = str_word_count($DisplayName, 1);
		        $DisplayName = $Nick[0]." ".$Nick[1]." ".$Nick[2];
		        $pessek_prc->chatUserVcardPublic($chat_user, $chat_user, "NICKNAME", $DisplayName);
		}else{
			$pessek_prc->chatUserVcardPublic($chat_user, $chat_user, "NICKNAME", $DisplayName);
		}
	    
	    }

	}

	public static function xmppHandleUserSettings($hook, $type, $value, $params) {

	    	$guid = elgg_get_logged_in_user_entity()->guid;
	    	$user = get_user($guid);

		$user_guid = (int) get_input('guid');
                $actor = get_user($user_guid); 
	    	$elgg_username = $actor->username;
	   	$current_lang = get_current_language();

		if (!$user instanceof \ElggUser){
		 	return;
		}
		$usergroup = elgg_echo('pessek_chat:settings:usergroup');
	    	$DisplayName = $actor->getDisplayName();
	    	
		$password2 = get_input('password2', null, false);
		$password = get_input('password', null, false);
		$old_password = base64_decode ($actor->pessekchat_secret_key);

	    	$chat_user = new \Pessek\PessekChat\PessekPrcConnector($elgg_username);

	    	if($chat_user->check_account() === true ){
		    	$pessek_prc = new \Pessek\PessekChat\PessekPrcXmlrpcElgg();
			$pessek_prc->chatUserVcardPublic($chat_user, $chat_user, "FN", $DisplayName);

			if(str_word_count($DisplayName)>3){
				$Nick = array();
				$Nick = str_word_count($DisplayName, 1);
				$DisplayName = $Nick[0]." ".$Nick[1]." ".$Nick[2];
				$pessek_prc->chatUserVcardPublic($chat_user, $chat_user, "NICKNAME", $DisplayName);
			}else{
				$pessek_prc->chatUserVcardPublic($chat_user, $chat_user, "NICKNAME", $DisplayName);
			}
		    	
	    	}
//
		if (!$user->isAdmin() && $actor->guid === $user->guid) {
			$currentPassword = get_input('current_password', null, false);
				if(isset($password) && $password!='' && isset($currentPassword) && $currentPassword!=''){

					if(strcmp($old_password, $currentPassword)==0){

						$chat_user = new \Pessek\PessekChat\PessekPrcConnector($elgg_username, $usergroup, $old_password, $password);

						if($chat_user->check_account() === true ){
					    		$chat_user->changePassword(); 
					    		//$actor->pessekchat_secret_key = base64_encode ($password);
							$base64_password = base64_encode ($password);
							$actor->pessekchat_secret_key = $base64_password;
							$actor->save();
						}
					}
			       
			    	 }
		}

		if ($user->isAdmin() && $actor->guid === $user->guid) {
			$currentPassword = get_input('current_password', null, false);
				if(isset($password) && $password!=''){

					if(strcmp($old_password, $currentPassword)==0){

						$chat_user = new \Pessek\PessekChat\PessekPrcConnector($elgg_username, $usergroup, $old_password, $password);

						if($chat_user->check_account() === true ){
					    		$chat_user->changePassword(); 
					    		//$actor->pessekchat_secret_key = base64_encode ($password);
							$base64_password = base64_encode ($password);
							$actor->pessekchat_secret_key = $base64_password;
							$actor->save();
						}
					}
			       
			    	 }
		}

		if ($user->isAdmin() && $actor->guid != $user->guid) { //register_error($DisplayName);register_error($elgg_username);register_error($old_password);
				if(isset($password) && $password!=''){

						$chat_user = new \Pessek\PessekChat\PessekPrcConnector($elgg_username, $usergroup, $old_password, $password);

						if($chat_user->changePassword() === true ){
					    		$chat_user->change_password(); 
					    		//$actor->pessekchat_secret_key = base64_encode ($password);
							$base64_password = base64_encode ($password);
							$actor->pessekchat_secret_key = $base64_password;
							$actor->save();
						}
			       
			    	 }
		}
//
	    	

	}

	public static function xmppUserUpdateByAdmin($event, $object_type, $user) {

	    if (!$user instanceof \ElggUser){
		 	return;
	    }
	    
	    $guid = (string)$user->guid ;
	    $elgg_username = $user->username;
	    $usergroup = elgg_echo('pessek_chat:settings:usergroup'); 

	    
	    $password = get_input('password', null, false); 
	    $DisplayName = get_input('name');
	    
	    if(isset($password)){
		$base64_password = base64_encode ($password);
		$user->pessekchat_secret_key = $base64_password;
		$user->save();
	    }
	    
	    if(!isset($DisplayName)){
		$DisplayName = $user->getDisplayName();
	    }
	    
	    $chat_user = new \Pessek\PessekChat\PessekPrcConnector($elgg_username);
	    
	    if($chat_user->check_account() === true ){
	    
		    $pessek_prc = new \Pessek\PessekChat\PessekPrcXmlrpcElgg();
                    $pessek_prc->chatUserVcardPublic($chat_user, $chat_user, "FN", $DisplayName);
		    if(str_word_count($DisplayName)>3){
		        
		        $Nick = array();
		        $Nick = str_word_count($DisplayName, 1);
		        $DisplayName = $Nick[0]." ".$Nick[1]." ".$Nick[2];
		        $pessek_prc->chatUserVcardPublic($chat_user, $chat_user, "NICKNAME", $DisplayName);
		            
		    }else{
			$pessek_prc->chatUserVcardPublic($chat_user, $chat_user, "NICKNAME", $DisplayName);
		    }

	    	}
	        if(isset($password)){
			$old_password = base64_decode ($user->pessekchat_secret_key);
			$password = base64_decode ($user->pessekchat_secret_key);
			$chat_user = new \Pessek\PessekChat\PessekPrcConnector($elgg_username, $usergroup, $old_password, $password);
			
			if($chat_user->check_account() === true ){
			    $chat_user->changePassword(); 
			}
		}
	}

}





